diff --git a/hubs/views/user.py b/hubs/views/user.py
index 692daf3..62866ae 100644
--- a/hubs/views/user.py
+++ b/hubs/views/user.py
@@ -5,7 +5,7 @@ import json
 import hubs.models
 import hubs.stream
 
-from hubs.app import app, session
+from hubs.app import app
 from .utils import login_required, get_hub
 
 
@@ -62,16 +62,20 @@ def notifications(user):
             dict(notification=notification.__json__(), success=True)
         )
 
+
 @app.route('/<user>/notifications/<int:idx>', methods=['DELETE'])
 @app.route('/<user>/notifications/<int:idx>/', methods=['DELETE'])
 @login_required
 def delete_notifications(user, idx):
-    notification = flask.g.db.query(hubs.models.SavedNotification).filter_by(idx=idx).first()
+    notification = flask.g.db.query(
+        hubs.models.SavedNotification).filter_by(idx=idx).first()
     if not notification:
         return flask.abort(400)
     flask.g.db.delete(notification)
     flask.g.db.commit()
     return flask.jsonify(dict(status_code=200))
+
+
 @app.route('/visit/<visited_hub>/', methods=['GET', 'POST'])
 @app.route('/visit/<visited_hub>', methods=['GET', 'POST'])
 @login_required
@@ -80,9 +84,8 @@ def increment_counter(visited_hub):
 
     if str(visited_hub) != str(nickname):
         try:
-            vc = hubs.models.VisitCounter.get_or_create(session=flask.g.db,
-                                                        username=nickname,
-                                                        visited_hub=visited_hub)
+            vc = hubs.models.VisitCounter.get_or_create(
+                session=flask.g.db, username=nickname, visited_hub=visited_hub)
         except ValueError:  # this should never trip
             # flask will 405 if visited_hub is blank
             # @login_required forces flask.g.auth to be sets
diff --git a/hubs/widgets/github_pr/__init__.py b/hubs/widgets/github_pr/__init__.py
index 07374fb..c5970f9 100644
--- a/hubs/widgets/github_pr/__init__.py
+++ b/hubs/widgets/github_pr/__init__.py
@@ -69,7 +69,7 @@ class GetPRs(CachedFunction):
                 for repo in repos
             ], [])
             # Reverse-sort by time (newest-first)
-            pulls.sort(lambda a, b: cmp(b['timestamp'], a['timestamp']))
+            pulls.sort(key=lambda x: x['timestamp'], reverse=True)
 
             # Some hints for display
             len_pulls = len(pulls)
diff --git a/hubs/widgets/validators.py b/hubs/widgets/validators.py
index 9c96320..a037a94 100644
--- a/hubs/widgets/validators.py
+++ b/hubs/widgets/validators.py
@@ -122,8 +122,7 @@ class FMNContext(Validator):
     @classmethod
     def from_string(cls, value):
         # TODO get this from the fedmsg config.
-        if value in [
-            'irc', 'email', 'android', 'desktop', 'hubs',]:
+        if value in ['irc', 'email', 'android', 'desktop', 'hubs']:
             return value
         raise ValueError('Invalid FMN context')
 
diff --git a/populate-from-fas.py b/populate-from-fas.py
index 959c5e4..b5ed9ce 100755
--- a/populate-from-fas.py
+++ b/populate-from-fas.py
@@ -1,7 +1,7 @@
 #!/usr/bin/env python
 """ Populate the hubs db with lots of data from FAS. """
 
-from __future__ import unicode_literals
+from __future__ import unicode_literals, print_function
 
 import getpass
 import socket
@@ -14,7 +14,7 @@ import fedmsg.config
 fedmsg_config = fedmsg.config.load_config()
 
 fasclient = fedora.client.fas2.AccountSystem(
-    username=raw_input('Your FAS username: '),
+    username=input('Your FAS username: '),
     password=getpass.getpass(),
 )
 timeout = socket.getdefaulttimeout()
@@ -39,7 +39,7 @@ suffix_blacklist = [
 for letter in reversed(sorted(list(set(string.letters.lower())))):
     session = hubs.models.init(
         fedmsg_config['hubs.sqlalchemy.uri'], True, True)
-    print "Querying FAS for the %r users.. hang on." % letter
+    print("Querying FAS for the %r users.. hang on." % letter)
     request = fasclient.send_request(
         '/user/list',
         req_params={'search': '%s*' % letter, 'status': 'active'},
@@ -50,7 +50,7 @@ for letter in reversed(sorted(list(set(string.letters.lower())))):
     for user in users:
         username = user['username']
         fullname = user['human_name']
-        print "Creating account for %r" % username
+        print("Creating account for %r" % username)
         hubs_user = hubs.models.User.get_or_create(
             session, username=username, fullname=fullname)
 
diff --git a/populate.py b/populate.py
index 5a5d5a2..08feaa3 100755
--- a/populate.py
+++ b/populate.py
@@ -35,7 +35,7 @@ for username in users:
 
 session.commit()
 
-############## Internationalizationteam
+# ############# Internationalizationteam
 hub = hubs.models.Hub(name='i18n', archived=True)
 session.add(hub)
 session.add(hubs.models.HubConfig(
@@ -45,13 +45,14 @@ widget = hubs.models.Widget(plugin='contact', index=-1)
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='stats', index=0)
 hub.widgets.append(widget)
-widget = hubs.models.Widget(plugin='rules', index=1,
-                            _config=json.dumps({
-                                'link': 'https://fedoraproject.org/wiki/I18N',
-                                'schedule_text': None,
-                                'schedule_link': None,
-                                'minutes_link': 'https://meetbot.fedoraproject.org/sresults/?group_id=i18n&type=team',
-                            }))
+widget = hubs.models.Widget(
+    plugin='rules', index=1, _config=json.dumps({
+        'link': 'https://fedoraproject.org/wiki/I18N',
+        'schedule_text': None,
+        'schedule_link': None,
+        'minutes_link': 'https://meetbot.fedoraproject.org/sresults/'
+                        '?group_id=i18n&type=team',
+    }))
 hub.widgets.append(widget)
 
 widget = hubs.models.Widget(plugin='meetings', index=2,
@@ -59,16 +60,25 @@ widget = hubs.models.Widget(plugin='meetings', index=2,
 hub.widgets.append(widget)
 
 # Added a hubs about widget
-widget = hubs.models.Widget(plugin='about', index=3,
-                            _config=json.dumps({
-                                "text": "I'm a Fedora user, and this is my about widget text!",
-                            }))
-hub.widgets.append(widget)
-
-widget = hubs.models.Widget(plugin='sticky', index=1, left=True,
-                            _config=json.dumps({
-                                'text': "<p>The Fedora I18N project works on internationalization (i18n) to support the localization (l10n) of Fedora in many languages. Translation of Fedora software and documentation are handled by the Fedora L10N project.</p> <p>The goals of the Project are to:</p> <ul><li>Develop, package, and maintain applications like input methods for different languages</li> <li>Improve applications and utilities to support and process different languages</li> <li>Quality-assure that existing applications meet i18n standards</li> <li>Support the infrastructure of the Fedora Localization Project</li></ul>",
-                            }))
+widget = hubs.models.Widget(
+    plugin='about', index=3, _config=json.dumps({
+        "text": "I'm a Fedora user, and this is my about widget text!",
+    }))
+hub.widgets.append(widget)
+
+widget = hubs.models.Widget(
+    plugin='sticky', index=1, left=True, _config=json.dumps({
+        'text': """
+<p>The Fedora I18N project works on internationalization (i18n) to support the
+localization (l10n) of Fedora in many languages. Translation of Fedora software
+and documentation are handled by the Fedora L10N project.</p> <p>The goals of
+the Project are to:</p> <ul><li>Develop, package, and maintain applications
+like input methods for different languages</li> <li>Improve applications and
+utilities to support and process different languages</li> <li>Quality-assure
+that existing applications meet i18n standards</li> <li>Support the
+infrastructure of the Fedora Localization Project</li></ul>
+""",
+    }))
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='dummy', index=2, left=True)
 hub.widgets.append(widget)
@@ -82,7 +92,7 @@ hub.subscribe(hubs.models.User.by_username('ralph'), 'subscriber')
 
 session.commit()
 
-############## CommOps
+# ############# CommOps
 hub = hubs.models.Hub(name='commops')
 session.add(hub)
 session.add(hubs.models.HubConfig(
@@ -92,17 +102,20 @@ widget = hubs.models.Widget(plugin='contact', index=-1)
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='stats', index=0)
 hub.widgets.append(widget)
-widget = hubs.models.Widget(plugin='rules', index=1,
-                            _config=json.dumps({
-                                'link': 'https://fedoraproject.org/wiki/CommOps',
-                                'schedule_text': None,
-                                'schedule_link': None,
-                                'minutes_link': 'http://meetbot.fedoraproject.org/sresults/?group_id=commops&type=team',
-                            }))
+widget = hubs.models.Widget(
+    plugin='rules', index=1, _config=json.dumps({
+        'link': 'https://fedoraproject.org/wiki/CommOps',
+        'schedule_text': None,
+        'schedule_link': None,
+        'minutes_link': 'http://meetbot.fedoraproject.org/sresults/'
+                        '?group_id=commops&type=team',
+    }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='meetings', index=2,
-                            _config=json.dumps({'calendar': 'commops', 'n_meetings': 4}))
+widget = hubs.models.Widget(
+    plugin='meetings', index=2, _config=json.dumps({
+        'calendar': 'commops', 'n_meetings': 4
+    }))
 hub.widgets.append(widget)
 
 # Added a hubs about widget
@@ -112,10 +125,12 @@ widget = hubs.models.Widget(plugin='about', index=3,
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='sticky', index=1, left=True,
-                            _config=json.dumps({
-                                'text': "Bringing more heat and light to Fedora, so you don't have to choose between 'building things' and 'building communities that build things.'",
-                            }))
+widget = hubs.models.Widget(
+    plugin='sticky', index=1, left=True, _config=json.dumps({
+        'text': "Bringing more heat and light to Fedora, so you don't have "
+                "to choose between 'building things' and 'building "
+                "communities that build things.'",
+    }))
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='dummy', index=2, left=True)
 hub.widgets.append(widget)
@@ -131,7 +146,7 @@ hub.subscribe(hubs.models.User.by_username('linuxmodder'), 'member')
 
 session.commit()
 
-############## Marketing team
+# ############# Marketing team
 hub = hubs.models.Hub(name='marketing')
 session.add(hub)
 session.add(hubs.models.HubConfig(
@@ -141,30 +156,41 @@ widget = hubs.models.Widget(plugin='contact', index=-1)
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='stats', index=0)
 hub.widgets.append(widget)
-widget = hubs.models.Widget(plugin='rules', index=1,
-                            _config=json.dumps({
-                                'link': 'https://fedoraproject.org/wiki/Marketing',
-                                'schedule_text': None,
-                                'schedule_link': None,
-                                'minutes_link': 'http://meetbot.fedoraproject.org/sresults/?group_id=fedora-mktg&type=channel',
-                            }))
+widget = hubs.models.Widget(
+    plugin='rules', index=1, _config=json.dumps({
+        'link': 'https://fedoraproject.org/wiki/Marketing',
+        'schedule_text': None,
+        'schedule_link': None,
+        'minutes_link': 'http://meetbot.fedoraproject.org/sresults/'
+                        '?group_id=fedora-mktg&type=channel',
+    }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='meetings', index=2,
-                            _config=json.dumps({'calendar': 'marketing', 'n_meetings': 4}))
+widget = hubs.models.Widget(
+    plugin='meetings', index=2, _config=json.dumps({
+        'calendar': 'marketing', 'n_meetings': 4
+    }))
 hub.widgets.append(widget)
 
 # Added a hubs about widget
-widget = hubs.models.Widget(plugin='about', index=3,
-                            _config=json.dumps({
-                                "text": "I'm a Fedora user, and this is my about widget text!",
-                            }))
-hub.widgets.append(widget)
-
-widget = hubs.models.Widget(plugin='sticky', index=1, left=True,
-                            _config=json.dumps({
-                                'text': "The Fedora Marketing Team develops and executes marketing strategies to promote the usage and support of Fedora worldwide. Through the development of processes and content, this project aims to support the efforts of other Fedora projects to spread Fedora and to provide a central repository of ideas and information that can be used to deliver Fedora to new audiences. We work closely with the Fedora Ambassadors who spread the word about Fedora at events and allow the Fedora Project to interact directly with its existing and prospective users. ",
-                            }))
+widget = hubs.models.Widget(
+    plugin='about', index=3, _config=json.dumps({
+        "text": "I'm a Fedora user, and this is my about widget text!",
+    }))
+hub.widgets.append(widget)
+
+widget = hubs.models.Widget(
+    plugin='sticky', index=1, left=True, _config=json.dumps({
+        'text': """
+The Fedora Marketing Team develops and executes marketing strategies to promote
+the usage and support of Fedora worldwide. Through the development of processes
+and content, this project aims to support the efforts of other Fedora projects
+to spread Fedora and to provide a central repository of ideas and information
+that can be used to deliver Fedora to new audiences. We work closely with the
+Fedora Ambassadors who spread the word about Fedora at events and allow the
+Fedora Project to interact directly with its existing and prospective users.
+""",
+    }))
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='dummy', index=2, left=True)
 hub.widgets.append(widget)
@@ -181,7 +207,7 @@ hub.subscribe(hubs.models.User.by_username('ralph'), 'subscriber')
 
 session.commit()
 
-############## Design team
+# ############# Design team
 hub = hubs.models.Hub(name='designteam')
 session.add(hub)
 session.add(hubs.models.HubConfig(
@@ -191,30 +217,37 @@ widget = hubs.models.Widget(plugin='contact', index=-1)
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='stats', index=0)
 hub.widgets.append(widget)
-widget = hubs.models.Widget(plugin='rules', index=1,
-                            _config=json.dumps({
-                                'link': 'https://fedoraproject.org/wiki/Design',
-                                'schedule_text': 'Meetings are every other Tuesday at 16:00 UTC',
-                                'schedule_link': 'https://apps.fedoraproject.org/calendar/design/',
-                                'minutes_link': 'http://meetbot.fedoraproject.org/sresults/?group_id=fedora-design&type=channel',
-                            }))
+widget = hubs.models.Widget(
+    plugin='rules', index=1, _config=json.dumps({
+        'link': 'https://fedoraproject.org/wiki/Design',
+        'schedule_text': 'Meetings are every other Tuesday at 16:00 UTC',
+        'schedule_link': 'https://apps.fedoraproject.org/calendar/design/',
+        'minutes_link': 'http://meetbot.fedoraproject.org/sresults/'
+                        '?group_id=fedora-design&type=channel',
+    }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='meetings', index=2,
-                            _config=json.dumps({'calendar': 'design', 'n_meetings': 4}))
+widget = hubs.models.Widget(
+    plugin='meetings', index=2, _config=json.dumps({
+        'calendar': 'design', 'n_meetings': 4
+    }))
 hub.widgets.append(widget)
 
 # Added a hubs about widget
-widget = hubs.models.Widget(plugin='about', index=3,
-                            _config=json.dumps({
-                                "text": "I'm a Fedora user, and this is my about widget text!",
-                            }))
+widget = hubs.models.Widget(
+    plugin='about', index=3, _config=json.dumps({
+        "text": "I'm a Fedora user, and this is my about widget text!",
+    }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='sticky', index=1, left=True,
-                            _config=json.dumps({
-                                'text': "The Design Team is the design group of the Fedora project. Our interests are not only in creating graphics for use by the Fedora community, but also in advocating the use of the creative tools that are a part of Fedora.",
-                            }))
+widget = hubs.models.Widget(
+    plugin='sticky', index=1, left=True, _config=json.dumps({
+        'text': """
+The Design Team is the design group of the Fedora project. Our interests are
+not only in creating graphics for use by the Fedora community, but also in
+advocating the use of the creative tools that are a part of Fedora.
+""",
+    }))
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='dummy', index=2, left=True)
 hub.widgets.append(widget)
@@ -232,7 +265,7 @@ hub.subscribe(hubs.models.User.by_username('ralph'), 'subscriber')
 session.commit()
 
 
-############## Infra team
+# ############# Infra team
 hub = hubs.models.Hub(name='infrastructure')
 session.add(hub)
 session.add(hubs.models.HubConfig(
@@ -242,30 +275,39 @@ widget = hubs.models.Widget(plugin='contact', index=-1)
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='stats', index=0)
 hub.widgets.append(widget)
-widget = hubs.models.Widget(plugin='rules', index=1,
-                            _config=json.dumps({
-                                'link': 'https://fedoraproject.org/wiki/Infrastructure',
-                                'schedule_text': 'We meet weekly in #fedora-meeting at 18:00 UTC',
-                                'schedule_link': 'https://apps.fedoraproject.org/calendar/infrastructure/',
-                                'minutes_link': 'http://meetbot.fedoraproject.org/sresults/?group_id=infrastructure&type=team',
-                            }))
+widget = hubs.models.Widget(
+    plugin='rules', index=1, _config=json.dumps({
+        'link': 'https://fedoraproject.org/wiki/Infrastructure',
+        'schedule_text': 'We meet weekly in #fedora-meeting at 18:00 UTC',
+        'schedule_link':
+            'https://apps.fedoraproject.org/calendar/infrastructure/',
+        'minutes_link': 'http://meetbot.fedoraproject.org/sresults/'
+                        '?group_id=infrastructure&type=team',
+    }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='meetings', index=2,
-                            _config=json.dumps({'calendar': 'infrastructure', 'n_meetings': 4}))
+widget = hubs.models.Widget(
+    plugin='meetings', index=2, _config=json.dumps({
+        'calendar': 'infrastructure', 'n_meetings': 4
+    }))
 hub.widgets.append(widget)
 
 # Added a hubs about widget
-widget = hubs.models.Widget(plugin='about', index=3,
-                            _config=json.dumps({
-                                "text": "I'm a Fedora user, and this is my about widget text!",
-                            }))
-hub.widgets.append(widget)
-
-widget = hubs.models.Widget(plugin='sticky', index=2, left=True,
-                            _config=json.dumps({
-                                'text': "The Infrastructure Team consists of dedicated volunteers and professionals managing the servers, building the tools and utilities, and creating new applications to make Fedora development a smoother process. We're located all over the globe and communicate primarily by IRC and e-mail. ",
-                            }))
+widget = hubs.models.Widget(
+    plugin='about', index=3, _config=json.dumps({
+        "text": "I'm a Fedora user, and this is my about widget text!",
+    }))
+hub.widgets.append(widget)
+
+widget = hubs.models.Widget(
+    plugin='sticky', index=2, left=True, _config=json.dumps({
+        'text': """
+The Infrastructure Team consists of dedicated volunteers and professionals
+managing the servers, building the tools and utilities, and creating new
+applications to make Fedora development a smoother process. We're located all
+over the globe and communicate primarily by IRC and e-mail.
+""",
+    }))
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='dummy', index=3, left=True)
 hub.widgets.append(widget)
diff --git a/runserver.py b/runserver.py
index 9552b0a..f41b3cd 100755
--- a/runserver.py
+++ b/runserver.py
@@ -3,7 +3,6 @@
 from __future__ import unicode_literals
 
 import argparse
-import sys
 import os
 
 parser = argparse.ArgumentParser(
@@ -32,7 +31,7 @@ if args.config:
     os.environ['HUBS_CONFIG'] = config
 
 
-from hubs.app import app
+from hubs.app import app  # noqa
 
 app.debug = True
 app.run(debug=True, host=args.host, port=int(args.port))
diff --git a/setup.py b/setup.py
index aa9b63e..cb267d0 100644
--- a/setup.py
+++ b/setup.py
@@ -26,8 +26,8 @@ setup(
     download_url="https://pypi.python.org/pypi/fedora-hubs/",
     license='AGPLv3+',
     install_requires=get_requirements(),
-    #tests_require=tests_require,
-    #test_suite='nose.collector',
+    # tests_require=tests_require,
+    # test_suite='nose.collector',
     packages=find_packages(),
     include_package_data=True,
     zip_safe=False,
@@ -40,7 +40,7 @@ setup(
     ],
     entry_points={
         'moksha.consumer': [
-            "cache_invalidator = hubs.backend.consumer:CacheInvalidatorExtraordinaire",
+            "cache_invalidator = hubs.backend.consumer:CacheInvalidatorExtraordinaire",  # noqa
         ],
     },
 )
diff --git a/smart_cache_invalidator.py b/smart_cache_invalidator.py
index ebf0de6..5150b0c 100755
--- a/smart_cache_invalidator.py
+++ b/smart_cache_invalidator.py
@@ -11,9 +11,7 @@ made to a widget without dropping the entire cache database.
 from __future__ import print_function, unicode_literals
 
 import argparse
-import os
 
-import dogpile.cache
 import fedmsg.config
 import fedmsg.meta
 
@@ -39,8 +37,8 @@ def do_list(args):
         widget = w_instance.module
         for fn_name, fn_class in widget.get_cached_functions().items():
             if fn_class(w_instance).is_cached():
-                print('- Widget cached {0} (#{1}) in {2}'.format(
-                          w_instance.hub_id, w_instance.idx, w_instance.plugin))
+                print(('- Widget cached {inst.hub_id} (#{inst.idx}) '
+                       'in {inst.plugin}').format(inst=w_instance))
 
 
 def do_clean(args):
diff --git a/tox.ini b/tox.ini
index 03e75ca..a77ac69 100644
--- a/tox.ini
+++ b/tox.ini
@@ -1,5 +1,5 @@
 [tox]
-envlist = py{27,34,35},js,docs
+envlist = py{27,34,35},js,docs,lint
 skipsdist = True
 
 

